* MW: make Outer_Syntax.command \<^command_keyword>\<open>problem\<close> a model for ..\<open>Example\<close>
  An ML syntax error should be indicated in place (in the string after \<^keyword>\<open>Given\<close> etc)
  and not on the definition as a whole. 
    - in MathEngBasic/problem "Outer_Syntax.command \<^command_keyword>\<open>problem\<close>" there are writeln
      and comments with testdata from "problem pbl_bieg : "Biegelinien"" in Biegelinie.thy
    - in MathEngBasic/problem there is guesswork ("TODO") how to reorganise "fun prep_input_PIDE"
      such that errors in "Given" etc are indicated WITHIN the term.

* ?MW?: In Outer_Syntax.command \<^command_keyword>\<open>Example\<close> is there a quick fix
  for successfully replacing hacked Problem.parse_cas by parse_references_input?
    (a) In addition to replacing Problem.parse_cas: How implement the optional parser:
      - Example "Diff_App/No.123 a" + NONE
      - Example "Diff_App/No.123 a" + SOME (probl_id, model_input, refs_input)
        i.e. we expect ISAC to present an empty template "Problem..Solution", but as a whole, to the user;
        see VSCode_Example.thy subsubsection \<open>Specification step by step\<close>
    How get Token.src for testing purposes?
    How can Scan.* be traced?
    (Tracing should help understanding Problem.parse_cas, Problem.parse_model_input which involve Scan.*)

* MW: check uses of Unsynchronized.ref vs. Synchronized.var;

* MW: clarify/eliminate Isabelle/Scala add-ons (presently unused)

    diff -r /home/makarius/isabelle/repos-Isabelle2021/src/Pure/build-jars ./src/Pure/build-jars
    11a12
    >   src/Tools/isac/BridgeJEdit/isac.scala

    diff -r /home/makarius/isabelle/repos-Isabelle2021/src/Pure/Tools/scala_project.scala ./src/Pure/Tools/scala_project.scala
    76a77
    >       "src/Tools/isac/etc" -> Path.explode("isabelle.isac"),

* Eliminate Thy_Info.get_theory eventually: should take theory from ancestory
  within current context.
    cf. e587c45cae0f note in Build_Thydata.thy

* Clarify symmetric rule: Thm.apply_attribute Calculation.symmetric thm context (!?);
    ??

* KEStore_Elems: Should we eliminate union_overwrite and use standard namespace merge?
  (Exception: rlss with its special cross-theory merge.)
    ? how adapt the different signatures ?
    union_overwrite: ('a * 'a -> bool) -> 'a list -> 'a list -> 'a list
    merge          : ('a * 'a -> bool) -> 'a list * 'a list -> 'a list

* What is the purpose of "#numeral" instead of plain numeral?
    ??

* Check/clarify Context.theory_name vs. Context.theory_long_name.
    present ISAC assumes 2 sessions in the MathEngine, Specify and Interpret, 
    and all Isac_Knowledge is in session Isac.
    So Context.theory_name suffices

* Eliminate mutable Rewrite_Ord.id (!?);
    shall be done in connection with cf. e587c45cae0f note in Build_Thydata.thy

* What is the idea behind KEStore_Elems.add_thes? How to do it properly in current Isabelle?
    https://static.miraheze.org/isacwiki/0/04/Isac-docu.pdf distinguishes 
    several kinds of ISAC users, in particular "math author (Mathematik-Autor)" and
    "course designer (Kurs-Designer)". The latter just adds examples which re-use existing
    knowledge designed by the former. KEStore_Elems.add_thes is an interface for the latter.   

* WN: proper ML antiquotations for "Tactical.Try" etc. --- be careful about unclear situations,
  e.g. "Tactical.Try" vs. "Lucas_Interpreter.Try";

* WN: Avoid Thm.get_name_hint and use Global_Theory.get_thm instead, get theory from References.T
    and push theory through as argument of respective functions.

* WN: more direct logical foundations wrt. Isabelle/HOL, eliminate many axiomatizations
    - quite often "axiomatization ..." can be turned into "lemma ... by auto"
      without further ado;
    - sometimes this requires to use more specific types / type classes;
    - sometimes this requires to use proper definitional mechanisms (e.g. 'primrec', 'fun');
    - a few "hard" cases will remain, to be reconsidered eventually (e.g. differentiation);

* WN: "fun pr_ord" is not required if used with @{make_string}, @{print}, @{print tracing};
    takes only static arguments ----------------^^^^^^^^^^^^^^, not value of "hd_ord (f, g)"
    ? are there better approximations to old output of (*1*) than with (*2*)
    (*1*)val _ = tracing ("hd_ord (f, g)      = " ^ ((pr_ord o hd_ord) (f, g)) );
    (*2*)val _ = @{print tracing}{a = "hd_ord (f, g)      = ", z = hd_ord (f, g)}(**)


* WN: Calculate.thy: add structure Calculate
* WN: cleanup method-def.sml, problem-def.sml, "eval-def.sml", "rewrite-order.sml"
* WN: MethodC.from_store throws exn 'get_pbt not found: ' ... confusing !! take 'ketype' as an argument

* WN: rewriting with ctxt not complete (cause errors hard to indentify later)
    - Prconditions.eval
    - Solve_Step.check ..Rewrite_Inst, Substitute, ..
    - Error_Pattern.check_for', fill_form
    - Derive.steps
    - Fetch_Tacs.specific_from_prog ?
    - Eval.adhoc_thm, adhoc_thm1_
    - ? LIST IS NOT COMPLETE

* WN: ? Rational.Cancel_p; extend use of \<^theory> to \<^theory_context>

* WN: redesign transition from Specification to Solution: how relate 
    - Formalise.model with variants (e.g. VSCode_Example)
      reconsider separation of variants F_I, F_II, see MAWEN paper
    - !?! I_Model of MethodC          (fairly free sequence, dependent on Formalise.model)
    - !?! formal arguments of program (fixed sequence)

* WN: ?How represent items, which have not yet been input?
   Note: For the purpose of user-guidance the format of requested input should be indicated!
    - proposal for how to indicate requested input: in VSCode_Example.thy subsubsection \<open>Empty Specification>
    - the trial with <fun is_empty> in Calculation.thy makes the question more precise: 
      better hack parsers or better work on ML_Syntax?

* WN: as soon as parsing in Outer_Syntax.command..‹Example› works, implement in Calculation
  - init_ctree, update_status, check_input


