(* Title:  Specify/formalise.sml
   Author: Walther Neuper 191026
   (c) due to copyright terms

A formalisation, \<open>Formalise\<close>, contains all items required to automatically solve a calculation
(and thus assist students in in all phases of problem solving):
(1) the \<open>values\<close> of \<open>Formalise.model\<close> for instantiating a \<open>Problem.model_input\<close>,
  accompanied with \<open>descriptor\<close>s for students, and
(2) \<open>Formalise.refs\<close> as defautlt \<open>References\<close> into Isac's 3-dimensional Know_Store,
  which can interactively be changed during problem solving.

\<open>Formalise\<close> of the root of a calculation might contain items,
which are required by \<open>Subproblem\<close>s (e.g. "errorBound" in case an equation 
cannot be solved symbolically and thus is solved numerically).
*)
signature FORMALISE =
sig
  type T
  val empty: T

  type model(*TODO revise: model list together with ERROR in
https://hg.risc.uni-linz.ac.at/wneuper/isa/file/51f6113384db/test/Tools/isac/BridgeJEdit/vscode-example.sml#l98*)
  type spec (*TODO: rename -> refs*)
end

(**)                   
structure Formalise(**): FORMALISE(**) =
struct
(**)

type model = Model_Def.form_model;
type spec = Model_Def.form_refs;

(* a formalization of an example contains data 
   sufficient for mechanically finding the solution for the example.
   FIXME.WN051014: dont store form_T = (_,form_refs) in the PblObj, this is done in origin *)
type T = Model_Def.form_T;
val empty = Model_Def.form_empty;

(**)end(**);
